#include maps\mp\_utility;

main()
{
maps\mp\mp_valley_fx::main();
maps\mp\sv_mortar::main();
maps\mp\sv_barrels::barrelInit();
maps\mp\sv_boats::main();
maps\mp\sv_doors::main();
maps\mp\_load::main();

//weapons respaws
WeaponRespawner("weapons", 60);

//entity removal in specific gametypes
gametypeallowed[0] = getcvar("g_gametype");
remove_script_label(gametypeallowed);

setExpFog(0.00015, 0.15, 0.14, 0.13, 0);
ambientPlay("ambient_mp_valley");

game["allies"] = "british";
game["axis"] = "german";
game["attackers"] = "allies";
game["defenders"] = "axis";
game["british_soldiertype"] = "normandy";
game["german_soldiertype"] = "normandy";

setCvar("r_glowbloomintensity0", "1");
setCvar("r_glowbloomintensity1", "1");
setcvar("r_glowskybleedintensity0",".25");

if(getcvar("g_gametype") == "hq")
{
level.radio = [];
level.radio[0] = spawn("script_model", (-928, -1564, 476));
level.radio[0].angles = (0, 270, 0);
level.radio[1] = spawn("script_model", (976.5, -582, 519));
level.radio[1].angles = (0, 45, 0);
level.radio[2] = spawn("script_model", (-882.5, -2873.8, 423));
level.radio[2].angles = (0, 0, 0);
level.radio[3] = spawn("script_model", (-938, -4088.9, 464));
level.radio[3].angles = (0, 240, 0);
level.radio[4] = spawn("script_model", (1285.5, -3593.8, 441));
level.radio[4].angles = (0, 0, 0);
level.radio[5] = spawn("script_model", (981.5, -3572.9, 589.9));
level.radio[5].angles = (0, 165, 0);
level.radio[6] = spawn("script_model", (85.5, -3449.1, 560));
level.radio[6].angles = (0, 345, 0);
level.radio[7] = spawn("script_model", (156.2, -2185.9, 444));
level.radio[7].angles = (0, 270, 0);
level.radio[8] = spawn("script_model", (1459.9, -2298.77, 461));
level.radio[8].angles = (0, 0, 0);
level.radio[9] = spawn("script_model", (245, 197.2, 627));
level.radio[9].angles = (0, 120, 0);
level.radio[10] = spawn("script_model", (-180, -956.8, 556));
level.radio[10].angles = (0, 0, 0);
level.radio[11] = spawn("script_model", (-458.9, -50.2, 489.978));
level.radio[11].angles = (359.9, 180, -8.46);
level.radio[12] = spawn("script_model", (-2098.9, -3426.2, 557));
level.radio[12].angles = (0, 180, 0);
level.radio[13] = spawn("script_model", (-2062.9, -4162.2, 592));
level.radio[13].angles = (0, 0, 0);
level.radio[14] = spawn("script_model", (-1853.7, -2339.56, 482));
level.radio[14].angles = (0, 270, 0);
level.radio[15] = spawn("script_model", (-2743.9, -1612.2, 588));
level.radio[15].angles = (0, 0, 0);
level.radio[16] = spawn("script_model", (-1794, -483.9, 441));
level.radio[16].angles = (0, 315, 0);
level.radio[16] = spawn("script_model", (-2696.6, -51.1, 416));
level.radio[16].angles = (0, 210, 0);
}

}

//script to remove entities from certain gametypes by sentchy
///////////////////////////////////////////////////
//add a key of script_noteworthy2 with the value of the game types the entities should appear in 
//separated by commas but no spaces, e.g script_noteworthy2="sd,hq"

remove_script_label(gametypeallowed)
{
  entitytypes = getentarray();
  for(i = 0; i < entitytypes.size; i++)
  {
    if(isdefined(entitytypes[i].script_noteworthy2))
    {
       println("^1Found a script_noteworth2 elememt");
       println("^1Model is: ", entitytypes[i].model);
       dodelete = true;

       for(j = 0; j < gametypeallowed.size; j++)
       {
         labelarr = strtok(entitytypes[i].script_noteworthy2,",");
         for( k = 0; k < labelarr.size; k++)
         {

           if(labelarr[k] == gametypeallowed[j])
           { 
             dodelete = false;
             break;
           }
         }
       }

       if(dodelete)
       {
         entitytypes[i] delete();
       }
     }
   }
}

//weapon function by sentchy.
////////////////////////////////////////
// Set the targetname to a value of your choice, e.g. "weapons" and use the same value to kick off your respawners
// Optional: Set count to the number of weapons that spawn at a time, e.g. 3 for three grenades at once
// Optional: set script_timescale to the time in seconds between respawns

//flesym : adding cvar mp_valley_weapons to remove these if required

WeaponRespawner(targetname, defaultrespawndelay)
{
weapons = getentarray(targetname, "targetname");

if(!isdefined(getcvar("mp_valley_weapons")))
	setcvar("mp_valley_weapons","1");

if(getcvar("mp_valley_weapons") != "0")
	setcvar("mp_valley_weapons","1");

weaponcvar = getcvar("mp_valley_weapons");

if(weapons.size > 0)
{
for(i=0; i < weapons.size; i++) 
{
if(weaponcvar == "1") {
	if(!isdefined(weapons[i].script_timescale))
	weapons[i].script_timescale = defaultrespawndelay;

	// kick off a thread to listen for when the item gets picked up
	weapons[i] thread weapon_think(weapons[i].script_timescale);
} else if (weaponcvar == "0") {
	weapons[i] delete();
}
}
}
}

// self = weapon reference
weapon_think(delaytime)
{
// capture important weapon data first to allow us to respawn them
classname = self.classname;
model = self.model;
count = self.count;
org = self.origin;
angles = self.angles;

targetname = self.targetname;

// Wait till the weapon gets picked up
self waittill("trigger");

// Wait the delay before respawn
wait delaytime;

// respawn the weapon
weapon = spawn(classname, org);
weapon.angles = angles;
weapon.count = count;
weapon setmodel(model); 
weapon.script_timescale = delaytime;
weapon.targetname = targetname;

// Kick off a new thread with the new weapon and kill the old one
weapon thread weapon_think(delaytime);
}

////////////////////////////////////