main()
{
	level thread precacheFX();
	level thread spawnWorldFX();
	level thread shockDeath();
	level thread bell();
	level thread waterNoProne();	
	level.scr_sound["flak88_explode"] = "flak88_explode";
}

precacheFX()
{
	//load all the required effects here
	//fire
	level._effect["building_fire_large"] = loadfx ("fx/fire/building_fire_large.efx");
	level._effect["building_fire_med"] = loadfx ("fx/fire/building_fire_med.efx");
	level._effect["building_fire_small"] = loadfx ("fx/fire/building_fire_small.efx");
	level._effect["fire_place"] = loadfx ("fx/fire/ground_fire_small_oneshot.efx");
	//smoke
	level._effect["battlefield_smokebank_S"] = loadfx ("fx/smoke/battlefield_smokebank_S.efx");
	level._effect["thin_light_smoke_M"] = loadfx ("fx/smoke/thin_light_smoke_M.efx");
	level._effect["thin_black_smoke_S"] = loadfx ("fx/smoke/thin_black_smoke_S.efx");
	//sparks
	level._effect["small_metalhit"] = loadfx ("fx/impacts/small_metalhit.efx");
	//explosion
	level._effect["flak_explosion"]		= loadfx("fx/explosions/flak88_explosion.efx");
}

spawnWorldFX()
{
	//call the appropriate effect for the appropriate "targetname"
	//use these "targetname" on script_origin entities in Radiant to place the effect in the map

	sparks = getentarray ("electricSpark","targetname");
	craters = getentarray ("craterSmoke","targetname");
	smokeBanks = getentarray ("smoke1","targetname");
	chimneys = getentarray ("chimneySmoke", "targetname");
	smallBlgFires = getentarray ("smallBlgFire","targetname");
	medBlgFires = getentarray ("medBlgFire","targetname");
	firePlaces = getentarray ("firePlace", "targetname");

	//sparks
	for( i = 0 ; i < sparks.size ; i++ ) 
	{
		sparks[i] thread maps\mp\_fx::loopfx("small_metalhit", sparks[i].origin, 0.2);
		sparks[i] playloopsound ("electric_spark");
	}

	//crater smoke
	for( i = 0 ; i < craters.size ; i++ )
		craters[i] thread maps\mp\_fx::loopfx("thin_light_smoke_M", craters[i].origin, 0.6);
	/*
	//smoke banks
	for( i = 0 ; i < smokeBanks.size ; i++ )
		smokeBanks[i] thread maps\mp\_fx::loopfx("battlefield_smokebank_S", smokeBanks[i].origin, 0.6);
	*/
	//chimney smoke
	for( i = 0 ; i < chimneys.size ; i++ )
		chimneys[i] thread maps\mp\_fx::loopfx("thin_black_smoke_S", chimneys[i].origin, 0.6);
	
	//small fires
	for( i = 0 ; i < smallBlgFires.size ; i++ )
	{
		smallBlgFires[i] thread maps\mp\_fx::loopfx("building_fire_small", smallBlgFires[i].origin, 2);
		smallBlgFires[i] playloopsound ("building_fire_small");
	}

	//medium fires
	for( i = 0 ; i < medBlgFires.size ; i++ )
	{
		medBlgFires[i] thread maps\mp\_fx::loopfx("building_fire_med", medBlgFires[i].origin, 2);
		medBlgFires[i] playloopsound ("building_fire_med"); 
	}

	//fire places
	for( i = 0 ; i < firePlaces.size ; i++ )
	{
		firePlaces[i] thread maps\mp\_fx::loopfx("fire_place", firePlaces[i].origin, 3.5);
		firePlaces[i] playloopsound ("building_fire_small"); 
	}
}

shockDeath()
{
	electricalDeath = getent ("electricalDeath", "targetname");

	while(1)
	{
		electricalDeath waittill ("trigger", player);

		electricalDeath.player = player;

		if ( !isdefined(electricalDeath.player.isshockchecked))
			electricalDeath.player.isshockchecked = false;

		if ( electricalDeath.player.isshockchecked == false ) {
			electricalDeath thread shockCheck();
			electricalDeath thread shockSound();
		}

		wait .1;
	}
}

shockCheck()
{

self.player.isshockchecked = true;

while (self.player istouching(self))
{
	if (self.player.health <= 0) {
		randb = randomInt(3);
		deathmethod1 = " ^7is totally fried.";	
		deathmethod2 = " ^7got zapped.";
		deathmethod3 = " ^7now smells like chicken.";
	
		if (randb == 0)
		iPrintLn( self.player.name, deathmethod1);
		if (randb == 1)
		iPrintLn( self.player.name, deathmethod2);
		if (randb == 2)
		iPrintLn( self.player.name, deathmethod3);
		
		break;
	}
	wait .1;
}
self.player.isshockchecked = false;
}

shockSound()
{
	electricalDeathOrigin = getent ("electricalDeathOrigin", "targetname");

	while (self.player istouching(self))
	{
		electricalDeathOrigin playsound ("electric_shock");
		wait 4;
	}
}


bell()
{
	bellTrigger = getent ("churchBellTrigger", "targetname"); //trigger_damage
	bellSoundOrigin = getent ("churchBellSound", "targetname"); //script_model
	bellModel = getent ("churchBellModel", "targetname"); //script_brushmodel

	bellTrigger waittill ("trigger", player);

	//plays the sound
	bellSoundOrigin playsound ("bell_hit");

	//bell movement
	bulletVector = vectornormalize(bellModel.origin - player.origin);
	bulletVectorX = vectordot( bulletVector, (-1,0,0));
	bulletVectorY = vectordot( bulletVector, (0,1,0));
	bellModel thread bellRotate(bulletVectorX, bulletVectorY);

	wait 0.1;
	//resets trigger
	thread bell();
}

bellRotate(angleX, angleY)
{
	angles = ((angleX*10),0,(angleY*10));
//	iprintlnbold ("amount1 = " + length(angles));

	self rotateto (angles, 0.25, 0, 0.25);
	self waittill ("rotatedone"); 

	angles = ((angleX*-4),0,(angleY*-4));
//	iprintlnbold ("amount2 = " + length(angles));

	self rotateto (angles, 0.5, 0.25, 0.25);
	self waittill ("rotatedone"); 

	angles = ((angleX),0,(angleY));
//	iprintlnbold ("amount3 = " + length(angles));

	self rotateto (angles, 0.4, 0.2, 0.2);
	self waittill ("rotatedone"); 

	angles = ((angleX/-2),0,(angleY/-2));
//	iprintlnbold ("amount4 = " + length(angles));

	self rotateto (angles, 0.3, 0.15, 0.15);
	self waittill ("rotatedone"); 

	self rotateto ((0,0,0), 0.2, 0.1, 0.1);
	self waittill ("rotatedone"); 
}


waterNoProne()
{
	level.waterD = getent("water_down", "targetname");
	level.waterU = getent("water_up", "targetname");

	while (1) {
		level.waterD waittill("trigger", thatPlayer);
		if (!isdefined(thatPlayer.isbeingchecked))
			thatPlayer.isbeingchecked = false;
		if (thatPlayer.isbeingchecked == false)
			thatPlayer thread drowningCheck();
		wait .1;
	}
}

drowningCheck()
{
	//iprintlnbold("drowningcheck starts");
	self.isbeingchecked = true;
	self.drowned = false;

	while(isalive(self) && self istouching(level.waterD))
	{
		while(!self istouching(level.waterU)) {
			wait 1;
			radiusDamage(self.origin,9, 10, 10);
			//iprintlnbold("player health = " + self.health);

			if (self.health <= 0) {
				self.drowned = true;
				break;
			}
		}
		wait .1;
	}

	self.isbeingchecked = false;

	if (self.drowned == true)
	{
		self.drowned = false;

		randb = randomInt(4);
		deathmethod1 = " ^7never learned to swim.";	
		deathmethod2 = " ^7drank too much water.";
		deathmethod3 = " ^7thought he could breathe under water.";
		deathmethod4 = " ^7sank like a brick.";
		
		if (randb == 0)
		iPrintLn( self.name, deathmethod1);
		if (randb == 1)
		iPrintLn( self.name, deathmethod2);
		if (randb == 2)
		iPrintLn( self.name, deathmethod3);
		if (randb == 3)
		iPrintLn( self.name, deathmethod4);

	}

}